<?php

function get_last_blogs( $display = 40) {
	global $wpdb, $wpmuBaseTablePrefix;
	if (isset($wpmuBaseTablePrefix)) {
		$blogs = $wpdb->get_results( "SELECT blog_id, domain, path 
										FROM $wpdb->blogs 
										WHERE site_id = '$wpdb->siteid' 
										  AND public = '1' 
										  AND archived = '0' 
										  AND mature = '0' 
										  AND spam = '0' 
										  AND deleted = '0' 
										  AND last_updated != '0000-00-00 00:00:00' 
										ORDER BY last_updated DESC 
										limit 0,$display"
									, ARRAY_A );

		foreach( $blogs as $cle => $details ) {
			if ( $wpdb->get_var("SELECT COUNT(*) nb_posts 
									FROM ". $wpmuBaseTablePrefix . 
									$details['blog_id'].
									"_posts") < 4 )
				unset($blogs[$cle]);
		}
	}
	return $blogs;
}


if ( function_exists('register_sidebar') ){
    register_sidebars(5);
    register_sidebar_widget(__('Search') .'diabolo', 'dia_widget_search');
    wp_register_sidebar_widget('links', __('Links').' diabolo', 'dia_widget_links', $class);
    wp_register_widget_control('links', __('Links').' diabolo', 'dia_widget_links_control', $dims90);
}


$themename = "Diabolo";
$shortname = "dia";
$theme_options = array (

	array(	"name" => "Body background color",
			"id" => $shortname."_body_background_color",
			"std" => "C6BDFF",
			"type" => "text"),

	array(	"name" => "Body background image",
			"id" => $shortname."_body_background_image",
			"std" => "",
			"type" => "text"),

	array(	"name" => "Banner background color",
			"id" => $shortname."_banner_background_color",
			"std" => "EFEFFF",
			"type" => "text"),

	array(	"name" => "Banner background image",
			"id" => $shortname."_banner_background_image",
			"std" => "",
			"type" => "text"),
			
	array(	"name" => "Banner font color",
			"id" => $shortname."_banner_font_color",
			"std" => "",
			"type" => "text"),
			
	array(	"name" => "Page background color",
			"id" => $shortname."_page_background_color",
			"std" => "E5E5FF",
			"type" => "text"),

	array(	"name" => "Sidebar (and Feed) background color",
			"id" => $shortname."_sidebarTitle_background_color",
			"std" => "B3C3F3",
			"type" => "text"),

	array(	"name" => "Sidebar (and feed) background image",
			"id" => $shortname."_sidebar_background_image",
			"std" => "",
			"type" => "text"),

	array(	"name" => "Navigation background color",
			"id" => $shortname."_nav_background_color",
			"std" => "B0C0F0",
			"type" => "text"),

	array(	"name" => "Page tab in nav background color",
			"id" => $shortname."_navPage_background_color",
			"std" => "D0D0F0",
			"type" => "text"),

	array(	"name" => "Post title background color",
			"id" => $shortname."_postTitle_background_color",
			"std" => "FFFFFF",
			"type" => "text"),

	array(	"name" => "Link color",
			"id" => $shortname."_link_color",
			"std" => "",
			"type" => "text"),

	array(	"name" => "Main column margins",
			"id" => $shortname."_main_column_margins",
			"std" => "0 200px 0 190px",
			"type" => "text"),

	array(	"name" => "Sidebar A float",
			"id" => $shortname."_sidebar_a_float",
			"std" => "left",
			"type" => "text"),

	array(	"name" => "Sidebar A margins",
			"id" => $shortname."_sidebar_a_margins",
			"std" => "0 0 0 10px",
			"type" => "text"),

	array(	"name" => "Sidebar B float",
			"id" => $shortname."_sidebar_b_float",
			"std" => "right",
			"type" => "text"),

	array(	"name" => "Sidebar B margins",
			"id" => $shortname."_sidebar_b_margins",
			"std" => "0 10px 0 0",
			"type" => "text"),
);

function mytheme_add_admin() {

	global $themename, $shortname, $theme_options;

	if ( $_GET['page'] == basename(__FILE__) ) {
	
		if ( 'save' == $_POST['action'] ) {
				$this_theme_options = $_POST;
				/*foreach ($theme_options as $value) {
					if( isset( $this_theme_options[ $value['id'] ] ) )
						$this_theme_options[ $value['id'] ], $this_theme_options[ $value['id'] ]  ); 
					else delete_option( $value['id'] );
				}*/

				update_option($themename.'_options', $this_theme_options);
				header("Location: themes.php?page=functions.php&saved=true");
				die;

		} else if( 'reset' == $_REQUEST['action'] ) {

			delete_option( $themename.'_options' );

			header("Location: themes.php?page=functions.php&reset=true");
			die;

		}
	}

    add_theme_page($themename." Options", "Diabolo Theme Options", 'edit_themes', basename(__FILE__), 'mytheme_admin');

}

function mytheme_admin() {

	global $themename, $shortname, $theme_options;

	if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings saved.</strong></p></div>';
	if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings reset.</strong></p></div>';
	
?>
<div class="wrap">
<h2><?php echo $themename; ?> settings</h2>

<form method="post">

<table class="optiontable">

<?php 
$this_theme_options = get_settings( $themename.'_options');
foreach ($theme_options as $value) { 
	
if ($value['type'] == "text") { ?>
		
<tr valign="top"> 
	<th scope="row"><?php echo $value['name']; ?>:</th>
	<td>
		<input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php echo (is_array($this_theme_options)) ? $this_theme_options[ $value['id'] ] : $value['std']; ?>" />
	</td>
	<td> default : <?php echo $value['std']; ?></td>
</tr>

<?php } elseif ($value['type'] == "select") { ?>

	<tr valign="top"> 
		<th scope="row"><?php echo $value['name']; ?>:</th>
		<td>
			<select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
				<?php foreach ($value['options'] as $option) { ?>
				<option<?php if ( $this_theme_options[ $value['id'] ] == $option) { echo ' selected="selected"'; } elseif ($option == $value['std']) { echo ' selected="selected"'; } ?>><?php echo $option; ?></option>
				<?php } ?>
			</select>
		</td>
	</tr>

<?php 
} 
}
?>

</table>

<p class="submit">
<input name="save" type="submit" value="Save changes" />	
<input type="hidden" name="action" value="save" />
</p>
</form>
<form method="post">
<p class="submit">
<input name="reset" type="submit" value="Reset" />
<input type="hidden" name="action" value="reset" />
</p>
</form>

<?php
}

function mytheme_wp_head() { ?>
<link href="<?php bloginfo('template_directory'); ?>/style.php" rel="stylesheet" type="text/css" />
<?php }

add_action('wp_head', 'mytheme_wp_head');
add_action('admin_menu', 'mytheme_add_admin'); 

function show_r($array) {
	echo "<table border='1'>\n";
	foreach ($array as $cle => $val) {
		echo "<tr><th>$cle</th><td>";
		if (is_array($val)) show_r($val);
		else echo $val;
		echo "</td></tr>\n";
	}	
	echo "</table>\n";
}
$this_theme_options = get_settings( $themename.'_options');
//show_r( $theme_options	);
?>